function f = f2dgauss(fsize,fsigma,cyx)

if numel(fsize)==1
    fsize = [fsize fsize];
end
if numel(fsigma)==1
    fsigma = [fsigma fsigma];
end

if nargin<3
    cyx = fsize/2;
end

m = fsize(1);
n = fsize(2);

[x,y] = meshgrid(1:uint32(n),1:uint32(m));
x = double(x)-0.5;
y = double(y)-0.5;
x = x - cyx(2);
y = y - cyx(1);


std_x = fsigma(2); %*n;
std_y = fsigma(1); %*m;
var_x = std_x^2;
var_y = std_y^2;
arg = -1/2 * (x.*x/var_x + y.*y/var_y);
% arg = - (x.^2 + y.^2)/fsigma(1)^2;
f = exp(arg);
