

clearvars
close all
clc
addpath('treeStaff');
fileType = 'jpg';
dataPath = ['D:\OTB\FaceOcc1\img'];
%%
data = dir([dataPath,'\*.',fileType]);
% num_frames = numel(data);
num_frames = 500;
first = 1;

%% annotate the first frame
ImageName=fullfile(dataPath,data(first).name);
d = imread(ImageName);
d = imresize(d, [size(d,1) size(d,2)]/2);
figure(1); imshow(d, []);
initRect = getrect;
initSize = initRect;
MaxLevel = 3;
%% Decision and evaluation issues
isTree = 0;
% writerObj = VideoWriter('deneme4.avi');
% open(writerObj);
for frame = first:num_frames
    ImageName=fullfile(dataPath,data(frame,1).name);
    im = imread(ImageName);
    im = imresize(im, [size(im,1) size(im,2)]/2);

    if frame == first
        rectBody = initRect;
        [dsst] = DSST_initialize(im,rectBody);
        [ treeTrack ] = init_tree(uint16(initRect(3:4)), dsst, MaxLevel);
    else
        if ~isTree
        [dsst]= DSST_track2(dsst,im,frame);
        rectBody = [round(dsst.rect)];
        else
        [ treeTrack, rectAvg ] = search_and_train2( treeTrack, im, rectBody, MaxLevel, uint16(initSize), frame);
        rectBody = rectAvg;
        end
                
        figure(2);imshow(im, []);
        rectangle('Position', rectBody,'LineWidth',2, 'EdgeColor', [1 0 0]);
        drawnow
    end
%     writeVideo(writerObj,imresize(frame2im(getframe(gcf)), [420,560]));
end

% close(writerObj);
