function [ w ] = learningthemask2( dsst, xt )

if dsst.psr < dsst.psrPrev*9
    % f = dsst.hf_num(:,:,1)./(dsst.hf_den(:,:,1)+dsst.lambda);
    f_num = dsst.hf_num; f_den = dsst.hf_den+dsst.lambda;
    x = xt;
%     x(end-size(x,1)/2:end,end-size(x,2)/2:end, :) = 0;
    % sX = size(x,2); sY = size(x,1);
    % SalMap = FourDirectionalSaliencyEps(double(x), 5, 1, 1, 0, 0);
    % SalMap = (mat2gray(SalMap));
    % SalMap = FourDirectionalSaliencyEps(double(x), 5, [uint8(sX/2)-uint8(sX/16) uint8(sX/2)+uint8(sX/16)],...
    %     [uint8(sY/2)-uint8(sY/16) uint8(sY/2)+uint8(sY/16)], 1, 0);
    % SalMap = (1-mat2gray(SalMap));
    w_i = single(f2dgauss([dsst.sz(1) dsst.sz(2)],0.5*[dsst.sz(1) dsst.sz(2)]));
    w = repmat(w_i,1,1,28);
    g = single(dsst.y);
    muR = 1;
%     figure(3); subplot(2,2,2); imshow(w, []);
    %     Ratio = max(max(g))/ max(max(real(ifft2(fft2(x).*f))));
    %     w = Ratio*w;
    imtemp = real(ifft2(sum(f_num .* fft2(w.*xt), 3) ./ f_den));
    imtemp = double(imtemp);
    figure(3); subplot(2,2,1); imshow(imtemp, []);
    PSR1 = (max(max(imtemp))-mean(mean(imtemp)))/sqrt(var(imtemp(:)));
    % disp(PSR1);
    for i = 1:30
        k = sum(fft2(w.*x).*f_num,3)./f_den-fft2(g);
        s = k.*conj(sum(f_num,3)./f_den);
        sreal = real(ifft2(s));
        wtemp = repmat(sreal,1,1,28).*x;
        w = w-muR*wtemp;%-0.1*muR*(w-w_i);
%         w = mat2gray(-wtemp);
        kreal = sum(sum(real(ifft2(k)).^2))
        
    end
    figure(3); subplot(2,2,2); imshow(w(:,:,1), []);
%     
    w = w.*repmat(w_i,1,1,28);
    figure(3); subplot(2,2,4); imshow(w(:,:,20), []);
    imtemp = real(ifft2(sum(f_num .* fft2(w.*xt), 3) ./ f_den));
    imtemp = double(imtemp);
    figure(3); subplot(2,2,3); imshow(imtemp, []);
    PSR2 = (max(max(imtemp))-mean(mean(imtemp)))/sqrt(var(imtemp(:)));
%     % disp(PSR2);
    sprintf('PSR1: %.2d, PSR2: %2d', PSR1, PSR2)
    
else
    w = single(hann(dsst.sz(1)) * hann(dsst.sz(2))');
    sprintf('PSR is high enough')
end

end

