function psr = mosse_computePSR(corrcc, max_corrcc, c, maskSize)

%find the location of mask window
maskLoc(1:2) = max(1,(c-(floor(maskSize/2))));
maskLoc(3:4) = min(size(corrcc),(c+(floor(maskSize/2))));

sidelobe = corrcc;
%mark the mask window with NaN
sidelobe(maskLoc(1):maskLoc(3),maskLoc(2):maskLoc(4)) = NaN;
sidelobe = sidelobe(:);
%remove the marked mask window
sidelobe(isnan(sidelobe)) = [];

psr = (max_corrcc - mean(sidelobe))/std(sidelobe);