function [swcf]= SWCF_after_initialize(swcf,im)
pos = swcf.pos;%[swcf.rect(2) + swcf.rect(4)/2 swcf.rect(1) + swcf.rect(3)/2]; %pos = swcf.pos;
sz = swcf.sz;

% extract the training sample feature map for the translation filter
xl = get_translation_sample(im, pos, sz, [swcf.currentScaleFactorX swcf.currentScaleFactorY], swcf.cos_window);

% calculate the translation filter update
xlf = fft2(xl);
new_hf_num = bsxfun(@times, swcf.yf, conj(xlf));
new_hf_den = sum(xlf .* conj(xlf), 3);

% extract the training sample feature map for the scale filter
[xsX, xsY] = get_scale_sample_for1D(im, pos, swcf.base_target_sz, swcf.currentScaleFactorX * swcf.scaleFactorsX, swcf.currentScaleFactorY * swcf.scaleFactorsY, swcf.scale_window, swcf.scale_model_sz);
% [xsX, xsY] = get_scale_sample(im, pos, swcf.base_target_sz, swcf.currentScaleFactorX * swcf.scaleFactorsX, swcf.currentScaleFactorY * swcf.scaleFactorsY, swcf.scale_window, swcf.scale_model_sz);

% calculate the scale filter update
xsfX = fft(xsX,[],2);
new_sf_numX = bsxfun(@times, swcf.ysf, conj(xsfX));
new_sf_denX = sum(xsfX .* conj(xsfX), 1);
xsfY = fft(xsY,[],2);
new_sf_numY = bsxfun(@times, swcf.ysf, conj(xsfY));
new_sf_denY = sum(xsfY .* conj(xsfY), 1);

    swcf.hf_den = new_hf_den;
    swcf.hf_num = new_hf_num;
    
    swcf.sf_denX = new_sf_denX;
    swcf.sf_numX = new_sf_numX;
    swcf.sf_denY = new_sf_denY;
    swcf.sf_numY = new_sf_numY;
swcf.hflong_den = xlf .* conj(xlf);
swcf.flag = 1;
% [Hwindowed] = learningthemaskH(swcf, xl);
% swcf.Hwindowed = Hwindowed;
end

