function [ wout ] = learningthemask( swcf, xt )
f = swcf.hf_num(:,:,1)./(swcf.hf_den(:,:,1)+1*swcf.lambda*10);
x = xt(:,:,1);
w_if = single(hann(swcf.sz(1)) * hann(swcf.sz(2))');
w = w_if;
g = swcf.y;
G = fft2(g);
muR = 0.25;
for i = 1:30
    k = fft2(w.*x).*f-G;
    s = (k).*conj(f);
    sreal = real(ifft2(s));
    wtemp = sreal.*x;
    w = w-muR*wtemp;
%     kreal = sum(sum(real(ifft2(k)).^2))
end
wout = w;
end


