function [] = mywrapper()

cleanup = onCleanup(@() exit() );

traxserver('setup', 'rectangle', 'path');

memory = [0 0 0 0];
cnt = 1;
rectBody = [0 0 0 0];
swcf = [];
scaleF = 1;
treeTrack = [];
while 1
    
    [image, region] = traxserver('wait');
    if isempty(image)
        break;
    end;
    im = imread(image);
    if ~isempty(region)
        if region(3)>150 || region(4)>150
            scaleF = 2;
        else
            scaleF = 1;
        end
    end
    if scaleF == 2
        im = imresize(im, (1/scaleF));
    end
    if ~isempty(region)
        cnt = 1;
        rectBody = region/scaleF;
        initRect = rectBody;
        swcf = [];
        [swcf] = SWCF_initialize(im,rectBody,1);
%         fprintf('\n initilizating');
    else
%         fprintf('\n start frame: %d', cnt);
        [swcf]= SWCF_track(swcf,im,cnt);

        rectBody = swcf.rect;
%         fprintf('\n start frame: %d', cnt);
%         rectBody
    end
    %% comment or uncomment depending on to visualize the resulting BBs and/or the instantaneous window
%     figure(1); imshow(im);
%     rectangle('Position', rectBody, 'LineWidth', 2, 'EdgeColor', [1 0 0]);
%     figure(2); imshow(swcf.cos_window, [])
%     drawnow;
    %%
    memory = scaleF*rectBody;
    traxserver('status', memory);
    cnt = cnt + 1;
end
end

